<#--
/* Copyright 2009-2011 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
 --> 
<#macro errordetect bool><#assign err=bool/></#macro>

<#macro colour cl sp idd><#assign req=sp/><#assign id=idd/><#assign class=cl/><#assign color="red"/><#if cl==1><#assign color="yellow"/><#else><#if cl==2><#assign color="green"/></#if></#if><#if cl==3><#assign color="black"/></#if></#macro>

<#macro showLinks req listed
	><#local testsCount = coverage.getCoverageTestCount(req.getQualifiedId())
	/><#local testPathList = coverage.getCoveragePaths(req.getQualifiedId())
	/><#local testCntList = coverage.getCoverageCounts(req.getQualifiedId())
	/><#if (testsCount>-1)><#local iterate = 0
		/><#list testPathList as path
			><#if !listed?seq_contains(path)
				><#assign pathname=path	
				><#if (pathname?length>50)><#assign pathname=(pathname?substring(0,25)+"..."+pathname?substring(pathname?length-25,pathname?length))></#if
				><a title='${path?js_string}' onclick = 'if(typeof openEditor != "undefined"){if(openEditor("${path}")!=null)return false;}window.location.href="${path?js_string}";' href = "#">${pathname}  </a><br
				><#assign listed = listed + [ path ] 
			/></#if
			><#if coverage.hasErrors("${req.getQualifiedId()}",path)
				><@errordetect 1
				/><#local errors_names=coverage.getErrorNamesForNodeAndTest(req.getQualifiedId(),path)
    	    	/><#local errors_desc=coverage.getErrorDescriptionsForNodeAndTest(req.getQualifiedId(),path)
				/><#local errors_links=coverage.getErrorLinksForNodeAndTest(req.getQualifiedId(),path)
					/><ul><#list 0..errors_names?size-1 as i><#local error_name=(errors_names[i])><#local error_desc=errors_desc[i]><#local error_link=errors_links[i]  
						><li title='${error_desc}'><#if error_link!=""><a style="color:black; text-decoration:none;"  onclick = 'if(typeof openEditor != "undefined"){if(openEditor("${error_link}")!=null)return false;}window.location.href="${error_link}";' href = "#"><span class="error">${error_name}</span></a><#else><span class="error">${error_name}</span></#if></li
					></#list></ul
			></#if></#list></#if				
></#macro>

<#macro showdoc dc path
	><#local childrenList = dc?children/><#if dc?node_name == "br"><br/><#else><#if dc?node_type = 'element'><#assign isImage=false/><#if dc?node_name=="img" || dc?node_name=="object"><#assign isImage=true/></#if
	><${dc?node_name} <#list dc.@@ as attr><#assign val=attr/><#if isImage && (attr?node_name=="src"||attr?node_name=="data")><#assign val=path+val/></#if>${attr?node_name}="${val}" </#list>></#if></#if><#if dc?node_name == "p"><p style="display: inline;"></#if
	><#assign error=false/><#assign double=0
	/><#if dc?node_name == "span"><#if dc.@class[0]?? && dc.@class[0]?contains('requality_text')
		><#if uid?? && uid == (dc.@class[0]?substring(dc.@class[0]?index_of("id_")+3))><#assign double=1/></#if
		><#assign uid = (dc.@class[0]?substring(dc.@class[0]?index_of("id_")+3))
		><#assign node = utils.getNodeByUUID(uid)!""
		><#if node!=""
			><#list utils.getNodeByUUID(uid).getRequirements() as req
				><#assign class=coverage.getCoverageClass(req)
				/><#if double == 1><@colour class 2 dc.@class[0]?substring(dc.@class[0]?index_of("id_")+3)/><#else><@colour class 1 dc.@class[0]?substring(dc.@class[0]?index_of("id_")+3)/></#if			
			></#list
		><#else
			><#assign class="orange"
			/><#assign req=-1
		/></#if></#if></#if
	><#if childrenList?size == 0
		><#if req??
			><#if req==-1
				><font class="broken_loc" title="location ${uid} is broken">${dc}</font
			><#else><#if req==2
				><@errordetect 0
				/><div class="context-menu hidden" id="${id}"><span id="font"				
					><#local loc = utils.getNodeByUUID(id)
					/><#list loc.getRequirements() as req><#if coverage.getCoverageClass(req)==1><div style="margin-bottom:5px;" class="yellow"></#if><#if coverage.getCoverageClass(req)==2><div style="margin-bottom:5px;" class="green"></#if><#if coverage.getCoverageClass(req)==0><div style="margin-bottom:5px;" class="red"></#if											
						><#assign fufid=utils.getFullName(req)?js_string
						><#assign ufid=fufid
						><#if (ufid?length>30)><#assign ufid=("..."+ufid?substring(ufid?length-30,ufid?length))></#if
							><#if showButtons><a style="font-weight:bold !important; color:black !important; text-decoration:none;" title='Select element "${fufid}" in Requality Explorer' onclick = 'if(selectNode!=="undefined")selectNode("${req.getQualifiedId()}");' href = "#">"${ufid}"</a><button class="addtest" onclick='callAddTest("${req.getQualifiedId()?js_string}");return false' title="Add new test to element">Add Test</button><br
							/><#else><span title='${fufid}' style="font-weight:bold !important; color:black !important;">"${ufid}"</span><br></#if><#assign listed=[]><@showLinks req listed
						/><#list req.getSortedChildren("TestPurpose") as tp><@showLinks tp listed/></#list
						></div						
					></#list				
				></span></div
				><#if err==1><font class="${color} texterror menu" number="${id}" >${dc}</font><#else><font class="${color} menu" number="${id}" >${dc}</font></#if><@colour 3 0 id/><#else>${dc}</#if
			><#if req==1><@colour class 2 id/></#if
		></#if></#if
	></#if
	><#list childrenList as child><@showdoc child path /></#list		
	><#if dc?node_name=="span" && (!req?? || req==-1)><#assign req=0/></#if
	><#if dc?node_name == "p"></p></#if><#if dc?node_name != "br" && dc?node_type = 'element'></${dc?node_name}></#if
></#macro>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<style type="text/css">

.green {
	background: #bcee68; 
}
.red {
	background: pink;
}
.yellow {
	background: #fff68f;
}
.error{	
	text-shadow: 0px 0px 1px red, 2px 2px 3px rgb(255, 182, 193);
}
.texterror{	
	border-bottom: 2px ridge red;
}

#reportheader {
	border-radius:5px 5px 0px 0px; 
	border: outset 1px grey; 
	width:100%;
    font-size:1.1em;
    padding-top:5px;
    padding-bottom:4px;
background: rgb(204,204,204);
background: -moz-linear-gradient(top,  rgba(204,204,204,1) 0%, rgba(238,238,238,1) 100%); /* FF3.6+ */
background: -webkit-gradient(linear, left top, left bottom, color-stop(0%,rgba(204,204,204,1)), color-stop(100%,rgba(238,238,238,1))); /* Chrome,Safari4+ */
background: -webkit-linear-gradient(top,  rgba(204,204,204,1) 0%,rgba(238,238,238,1) 100%); /* Chrome10+,Safari5.1+ */
background: -o-linear-gradient(top,  rgba(204,204,204,1) 0%,rgba(238,238,238,1) 100%); /* Opera 11.10+ */
background: -ms-linear-gradient(top,  rgba(204,204,204,1) 0%,rgba(238,238,238,1) 100%); /* IE10+ */
background: linear-gradient(to bottom,  rgba(204,204,204,1) 0%,rgba(238,238,238,1) 100%); /* W3C */
filter: progid:DXImageTransform.Microsoft.gradient( startColorstr='#cccccc', endColorstr='#eeeeee',GradientType=0 ); /* IE6-9 */
}
ul {
	list-style-type: none;
	margin-bottom: 0px;
	margin-top: 0px;
	margin-left:-30px;
}

a:link{
	color:#236b8e;
}
a:visited{
	color:#191970;
}
a:focus {
	color:#2f2f4f;
	text-shadow: 0px 0px 1px #2f2f4f, 1px 1px 2px #2f2f4f;
}
a:hover{
	text-shadow: 0px 0px 1px grey;
}

.broken_loc{
	background: silver;
}
.addtest{
	width: 100px;
	cursor: pointer; cursor: hand;
}

#font{
	vertical-align: 0px;
	text-transform: none;
	text-decoration: none;
	text-indent: 0px;
	color: black;
	word-spacing: 0px;
	letter-spacing: 0px;
	font-weight: normal;
	font-style: normal;
	font-variant: normal;
	font-size: 16px;
	font-family: Time New Roman, serif;
}

.context-menu {
    position: absolute; 
    padding:10px;
    border: 1px ridge silver;
    box-shadow: 5px 5px 10px rgba(122, 122, 122, 0.5);
	border-radius: 3px;
	background: #eee;
	background: -moz-linear-gradient(top,  rgba(255,255,255,1) 0%, rgba(246,246,246,1) 47%, rgba(237,237,237,1) 100%); /* FF3.6+ */
	background: -webkit-gradient(linear, left top, left bottom, color-stop(0%,rgba(255,255,255,1)), color-stop(47%,rgba(246,246,246,1)), color-stop(100%,rgba(237,237,237,1))); /* Chrome,Safari4+ */
	background: -webkit-linear-gradient(top,  rgba(255,255,255,1) 0%,rgba(246,246,246,1) 47%,rgba(237,237,237,1) 100%); /* Chrome10+,Safari5.1+ */
	background: -o-linear-gradient(top,  rgba(255,255,255,1) 0%,rgba(246,246,246,1) 47%,rgba(237,237,237,1) 100%); /* Opera 11.10+ */
	background: -ms-linear-gradient(top,  rgba(255,255,255,1) 0%,rgba(246,246,246,1) 47%,rgba(237,237,237,1) 100%); /* IE10+ */
	background: linear-gradient(to bottom,  rgba(255,255,255,1) 0%,rgba(246,246,246,1) 47%,rgba(237,237,237,1) 100%); /* W3C */
	filter: progid:DXImageTransform.Microsoft.gradient( startColorstr='#ffffff', endColorstr='#ededed',GradientType=0 ); /* IE6-9 */
}

.block {
	width:auto;
	clear:both; 
	padding:10px;	
	background:rgba(184,186,198, 0.1); 
	border: outset 1px silver;
	border-top:none;
	border-radius: 0px 0px 5px 5px;
	box-shadow: 5px 5px 10px rgba(122, 122, 122, 0.5);
}

div.hidden{
	display: none;
	height:0px;
    overflow: hidden;
}

#container {
  background: white; 
}

#header {
   height: 70px;
   width: 1000px auto;
   border-radius: 5px 5px 0 0;
background: rgb(204,204,204);
background: -moz-linear-gradient(top,  rgba(204,204,204,1) 0%, white 100%); /* FF3.6+ */
background: -webkit-gradient(linear, left top, left bottom, color-stop(0%,rgba(204,204,204,1)), color-stop(100%, white)); /* Chrome,Safari4+ */
background: -webkit-linear-gradient(top,  rgba(204,204,204,1) 0%, white 100%); /* Chrome10+,Safari5.1+ */
background: -o-linear-gradient(top,  rgba(204,204,204,1) 0%, white 100%); /* Opera 11.10+ */
background: -ms-linear-gradient(top,  rgba(204,204,204,1) 0%, white 100%); /* IE10+ */
background: linear-gradient(to bottom,  rgba(204,204,204,1) 0%, white 100%); /* W3C */
filter: progid:DXImageTransform.Microsoft.gradient( startColorstr='#cccccc', endColorstr='white',GradientType=0 ); /* IE6-9 */
}

#header h1{
	font: bold 36px Arial serif;
	margin: 0px;
	padding-top:10px;
	text-align: center;
	text-shadow: 1px 1px 0 #8E9FA5;
}
	
#footer {
   height: 30px;
   width: 1000px auto;
   text-align: right;
   padding-top:10px;
   border-radius: 0 0 5px 5px;
background: rgb(245,246,246);
background: -moz-linear-gradient(top,  white 0%, rgba(219,220,226,1) 54%, rgba(184,186,198,1) 97%, rgba(184,186,198,1) 97%); /* FF3.6+ */
background: -webkit-gradient(linear, left top, left bottom, color-stop(0%, white), color-stop(54%,rgba(219,220,226,1)), color-stop(97%,rgba(184,186,198,1)), color-stop(97%,rgba(184,186,198,1))); /* Chrome,Safari4+ */
background: -webkit-linear-gradient(top,  white 0%,rgba(219,220,226,1) 54%,rgba(184,186,198,1) 97%,rgba(184,186,198,1) 97%); /* Chrome10+,Safari5.1+ */
background: -o-linear-gradient(top,  white 0%,rgba(219,220,226,1) 54%,rgba(184,186,198,1) 97%,rgba(184,186,198,1) 97%); /* Opera 11.10+ */
background: -ms-linear-gradient(top,  white 0%,rgba(219,220,226,1) 54%,rgba(184,186,198,1) 97%,rgba(184,186,198,1) 97%); /* IE10+ */
background: linear-gradient(to bottom,  white 0%,rgba(219,220,226,1) 54%,rgba(184,186,198,1) 97%,rgba(184,186,198,1) 97%); /* W3C */
filter: progid:DXImageTransform.Microsoft.gradient( startColorstr='white', endColorstr='#b8bac6',GradientType=0 ); /* IE6-9 */
}
</style>
	<script type="text/javascript">
	function docclick(e) {
 		evt = e ? e:window.event;
		var menus = document.getElementsByClassName("shown");
		for(var i = 0;i<menus.length;i++)
			menus[i].className="context-menu hidden";
		if(e.target.className.indexOf("menu")>0){
			if (e.button == 2 || e.button == 3) {
				var n = e.target.getAttribute("number");
				e.target.className+=" selected-html-element";
				var menu = document.getElementById(n);
				menu.className = "context-menu shown";
				menu.display = "";
				
 				var clickX=0, clickY=0;

				if ((evt.clientX || evt.clientY) &&
     			document.body &&
     			document.body.scrollLeft!=null) {
  					clickX = evt.clientX + document.body.scrollLeft;
  					clickY = evt.clientY + document.body.scrollTop;
 				}
 				if ((evt.clientX || evt.clientY) &&
     			document.compatMode=='CSS1Compat' && 
     			document.documentElement && 
     			document.documentElement.scrollLeft!=null) {
  					clickX = evt.clientX + document.documentElement.scrollLeft;
  					clickY = evt.clientY + document.documentElement.scrollTop;
 				}
 				if (evt.pageX || evt.pageY) {
  					clickX = evt.pageX;
  					clickY = evt.pageY;
 				}
 				
				menu.style.position = "absolute";
				menu.style.top = clickY+"px";
				menu.style.left = clickX+"px";
				return false;
			}
		}
	};
	document.onclick = document.oncontextmenu = docclick;
</script>
</head>

<body>
<div id="container">
<div id="header"><h1>Requality Project</h1></div>

<#if coverageFilePath?? || coverageStorageType??>
	<#if coverage.loadStorage()>
		<#if noAddTestButtons?? && noAddTestButtons!="false">
			<#assign showButtons = false>
		<#else>
			<#assign showButtons = true>
		</#if>
			<h1 style="margin-bottom:0px;"><table id="reportheader"><tr><th>Contents:</th></tr></table></h1>
			<div class="block"><ul>
				<#list utils.getDocuments() as doc>
					<li><a href="#${doc.getQualifiedId()?js_string}">${doc.getQualifiedId()}</a></li>
				</#list>
			</ul></div>
		<br>
		<#list utils.getDocuments() as doc>
				<#assign path="images/"+doc.getUUId()+"/">
				${doc.duplicateImages(reportLocation+"/"+path)}
				<h1 style="margin-bottom:0px;"><a id="${doc.getQualifiedId()?js_string}"/><table id="reportheader"><tr><th>${doc.getQualifiedId()}</th></tr></table></h1>
				<div class="block"><@showdoc doc.getNodeModel() path/></div>
			<br>
		</#list>		
	<#else>
		<#if coverageFilePath??>
			Coverage information cannot be loaded from 	${coverageFilePath}. 
Errors: ${coverage.getLastErrors()}
		<#else>
			Coverage information cannot be loaded from chosen source. Errors: 
${coverage.getLastErrors()}
		</#if>
	</#if>
<#else>
	There is no source of coverage information.<br>
	If using Eclipse plugin please use 'Update Coverage Source' menu on your report node in Requality Explorer.<br>
	If using console mode please set 'coverageFilePath' parameter as -coverageFilePath="path to coverage info file". 
</#if>

<div id="footer">2014</div>
</div>
</body>
</html>